/*
   Copyright 2009 Timo Schneider <timos@hrz.tu-chemnitz.de>
   
   This file is part of Tgtd.
   
   Tgtd is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   Tgtd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with Tgtd.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <map>
#include <string>
#include <vector>
#include <fstream>
#include <sstream>
#include <iostream>

#include <gloox/client.h>
#include <gloox/messagehandler.h>
#include <gloox/subscriptionhandler.h>
#include <gloox/rostermanager.h>
#include <gloox/presencehandler.h>

#include <log4cxx/logger.h>
#include <log4cxx/helpers/pool.h>
#include <log4cxx/basicconfigurator.h>
#include <log4cxx/fileappender.h>
#include <log4cxx/simplelayout.h>
#include <log4cxx/helpers/exception.h>

#include <boost/regex.hpp>

#include "Storage.hpp"

using namespace gloox;

class Bot : public MessageHandler, SubscriptionHandler, PresenceHandler {
  
 private:
	Client* j;
	Storage* stor;
	std::string jid_full;
	std::string password;

	static log4cxx::LoggerPtr logger;
	std::map<std::string, Presence> resource_status; 

	void send_todos(Stanza* stanza);

 public:
	virtual void handleMessage( Stanza* stanza, MessageSession* session = 0 );
	virtual void handleSubscription(Stanza *stanza);
	virtual void handlePresence(Stanza *stanza);

	void set_storage(Storage* s);
	void set_jid_full(std::string);
	void set_password(std::string);
	void start_bot();
};
