/*
   Copyright 2009 Timo Schneider <timos@hrz.tu-chemnitz.de>
   
   This file is part of Tgtd.
   
   Tgtd is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   Tgtd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with Tgtd.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _STORAGE_HPP
#define _STORAGE_HPP 1

#include <cstdlib>
#include <string>

#include <log4cxx/logger.h>
#include <log4cxx/basicconfigurator.h>
#include <log4cxx/helpers/exception.h>

#include <sqlite3.h>

#include "cmdline.h"

class Storage {
	private:
		sqlite3* Database;
		gengetopt_args_info *args_info;
		static log4cxx::LoggerPtr logger;
		bool prepare_sql_query(std::string sql, sqlite3_stmt **stmt);
		int get_dbuserid_from_jid(std::string jid);
	public:
		Storage(std::string Path);
		~Storage();
		bool check_if_jid_is_registred(std::string jid);
		int get_number_of_tasks_for_jid(std::string jid);
		std::vector<std::string> get_tasks_for_jid(std::string jid);
		void add_task_for_user(std::string task, std::string jid);
		void delete_task_for_user(int tasknum, std::string jid);
};

#endif
